# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rc_reason_msgs/LoadCarrierModel.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import rc_reason_msgs.msg
import std_msgs.msg

class LoadCarrierModel(genpy.Message):
  _md5sum = "6e5092ac65ce482648fedf509c5f775d"
  _type = "rc_reason_msgs/LoadCarrierModel"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# This represents a load carrier by its geometry and its pose

string id

# Optional. The load carrier rim model. The only supported value is STANDARD
string type

# Required
Box outer_dimensions

# Required
Box inner_dimensions

# Optional. If not provided, the rim thickness is computed from the outer and inner dimensions
Rectangle rim_thickness

# Optional. Height of the rim step for rims with an L-profile.
float64 rim_step_height

# Optional. Length of the rim ledge in x and y direction. This requires rim_thickness to be set.
Rectangle rim_ledge

# Optional. Height of the open side of a 3-sided load carrier measured from the outer bottom.
float64 height_open_side

# When setting a load carrier, this is the prior if frame_id is not empty (should be 'camera' or 'external')
geometry_msgs/PoseStamped pose

# Optional. Indicates how to interpret the load carrier pose
# If not set and pose is zero, it's equivalent to NO_POSE
# If not set and any value in pose is not zero, it's equivalent to ORIENTATION_PRIOR
# Valid values are:
# NO_POSE
# EXACT_POSE
# ORIENTATION_PRIOR
string pose_type

================================================================================
MSG: rc_reason_msgs/Box
# Definition of a box

float64 x
float64 y
float64 z

================================================================================
MSG: rc_reason_msgs/Rectangle
# Definition of a rectangle

float64 x
float64 y

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['id','type','outer_dimensions','inner_dimensions','rim_thickness','rim_step_height','rim_ledge','height_open_side','pose','pose_type']
  _slot_types = ['string','string','rc_reason_msgs/Box','rc_reason_msgs/Box','rc_reason_msgs/Rectangle','float64','rc_reason_msgs/Rectangle','float64','geometry_msgs/PoseStamped','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       id,type,outer_dimensions,inner_dimensions,rim_thickness,rim_step_height,rim_ledge,height_open_side,pose,pose_type

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(LoadCarrierModel, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.id is None:
        self.id = ''
      if self.type is None:
        self.type = ''
      if self.outer_dimensions is None:
        self.outer_dimensions = rc_reason_msgs.msg.Box()
      if self.inner_dimensions is None:
        self.inner_dimensions = rc_reason_msgs.msg.Box()
      if self.rim_thickness is None:
        self.rim_thickness = rc_reason_msgs.msg.Rectangle()
      if self.rim_step_height is None:
        self.rim_step_height = 0.
      if self.rim_ledge is None:
        self.rim_ledge = rc_reason_msgs.msg.Rectangle()
      if self.height_open_side is None:
        self.height_open_side = 0.
      if self.pose is None:
        self.pose = geometry_msgs.msg.PoseStamped()
      if self.pose_type is None:
        self.pose_type = ''
    else:
      self.id = ''
      self.type = ''
      self.outer_dimensions = rc_reason_msgs.msg.Box()
      self.inner_dimensions = rc_reason_msgs.msg.Box()
      self.rim_thickness = rc_reason_msgs.msg.Rectangle()
      self.rim_step_height = 0.
      self.rim_ledge = rc_reason_msgs.msg.Rectangle()
      self.height_open_side = 0.
      self.pose = geometry_msgs.msg.PoseStamped()
      self.pose_type = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_12d3I().pack(_x.outer_dimensions.x, _x.outer_dimensions.y, _x.outer_dimensions.z, _x.inner_dimensions.x, _x.inner_dimensions.y, _x.inner_dimensions.z, _x.rim_thickness.x, _x.rim_thickness.y, _x.rim_step_height, _x.rim_ledge.x, _x.rim_ledge.y, _x.height_open_side, _x.pose.header.seq, _x.pose.header.stamp.secs, _x.pose.header.stamp.nsecs))
      _x = self.pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.pose.pose.position.x, _x.pose.pose.position.y, _x.pose.pose.position.z, _x.pose.pose.orientation.x, _x.pose.pose.orientation.y, _x.pose.pose.orientation.z, _x.pose.pose.orientation.w))
      _x = self.pose_type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.outer_dimensions is None:
        self.outer_dimensions = rc_reason_msgs.msg.Box()
      if self.inner_dimensions is None:
        self.inner_dimensions = rc_reason_msgs.msg.Box()
      if self.rim_thickness is None:
        self.rim_thickness = rc_reason_msgs.msg.Rectangle()
      if self.rim_ledge is None:
        self.rim_ledge = rc_reason_msgs.msg.Rectangle()
      if self.pose is None:
        self.pose = geometry_msgs.msg.PoseStamped()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.type = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.type = str[start:end]
      _x = self
      start = end
      end += 108
      (_x.outer_dimensions.x, _x.outer_dimensions.y, _x.outer_dimensions.z, _x.inner_dimensions.x, _x.inner_dimensions.y, _x.inner_dimensions.z, _x.rim_thickness.x, _x.rim_thickness.y, _x.rim_step_height, _x.rim_ledge.x, _x.rim_ledge.y, _x.height_open_side, _x.pose.header.seq, _x.pose.header.stamp.secs, _x.pose.header.stamp.nsecs,) = _get_struct_12d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.pose.pose.position.x, _x.pose.pose.position.y, _x.pose.pose.position.z, _x.pose.pose.orientation.x, _x.pose.pose.orientation.y, _x.pose.pose.orientation.z, _x.pose.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose_type = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.pose_type = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_12d3I().pack(_x.outer_dimensions.x, _x.outer_dimensions.y, _x.outer_dimensions.z, _x.inner_dimensions.x, _x.inner_dimensions.y, _x.inner_dimensions.z, _x.rim_thickness.x, _x.rim_thickness.y, _x.rim_step_height, _x.rim_ledge.x, _x.rim_ledge.y, _x.height_open_side, _x.pose.header.seq, _x.pose.header.stamp.secs, _x.pose.header.stamp.nsecs))
      _x = self.pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.pose.pose.position.x, _x.pose.pose.position.y, _x.pose.pose.position.z, _x.pose.pose.orientation.x, _x.pose.pose.orientation.y, _x.pose.pose.orientation.z, _x.pose.pose.orientation.w))
      _x = self.pose_type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.outer_dimensions is None:
        self.outer_dimensions = rc_reason_msgs.msg.Box()
      if self.inner_dimensions is None:
        self.inner_dimensions = rc_reason_msgs.msg.Box()
      if self.rim_thickness is None:
        self.rim_thickness = rc_reason_msgs.msg.Rectangle()
      if self.rim_ledge is None:
        self.rim_ledge = rc_reason_msgs.msg.Rectangle()
      if self.pose is None:
        self.pose = geometry_msgs.msg.PoseStamped()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.type = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.type = str[start:end]
      _x = self
      start = end
      end += 108
      (_x.outer_dimensions.x, _x.outer_dimensions.y, _x.outer_dimensions.z, _x.inner_dimensions.x, _x.inner_dimensions.y, _x.inner_dimensions.z, _x.rim_thickness.x, _x.rim_thickness.y, _x.rim_step_height, _x.rim_ledge.x, _x.rim_ledge.y, _x.height_open_side, _x.pose.header.seq, _x.pose.header.stamp.secs, _x.pose.header.stamp.nsecs,) = _get_struct_12d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.pose.pose.position.x, _x.pose.pose.position.y, _x.pose.pose.position.z, _x.pose.pose.orientation.x, _x.pose.pose.orientation.y, _x.pose.pose.orientation.z, _x.pose.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose_type = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.pose_type = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_12d3I = None
def _get_struct_12d3I():
    global _struct_12d3I
    if _struct_12d3I is None:
        _struct_12d3I = struct.Struct("<12d3I")
    return _struct_12d3I
_struct_7d = None
def _get_struct_7d():
    global _struct_7d
    if _struct_7d is None:
        _struct_7d = struct.Struct("<7d")
    return _struct_7d
