# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rc_reason_msgs/ComputeGraspsRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import rc_reason_msgs.msg

class ComputeGraspsRequest(genpy.Message):
  _md5sum = "fa640774f984fc6944b698c3211fbfaa"
  _type = "rc_reason_msgs/ComputeGraspsRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Description: Triggers the computation of grasp poses for the given items and suction surface.

# Required. Pose frame for output poses (valid values are camera and external)
string pose_frame

# Optional
string region_of_interest_id

# Optional
string load_carrier_id

# Optional
Compartment load_carrier_compartment

# Optional. If empty, means one item of type unknown without dimensions
ItemModel[] item_models

# Required. Dimensions of the gripper suction surface
# In case of circular suction cups, the two values are expected to be the same and set to the suction cup diameter
# Different values are expected for grippers with multiple suction cups or non-circular suction cups (e.g. oval cups)
float64 suction_surface_length
float64 suction_surface_width

# Required only if reference frame = external and sensor is robot-mounted
geometry_msgs/Pose robot_pose

# Optional. Enables collision checking of grasps with load carrier
CollisionDetection collision_detection


================================================================================
MSG: rc_reason_msgs/Compartment
# Definition of a load carrier compartment

# The pose of the compartment is relative to the load carrier
geometry_msgs/Pose pose

# Size of the compartment
Box box

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: rc_reason_msgs/Box
# Definition of a box

float64 x
float64 y
float64 z

================================================================================
MSG: rc_reason_msgs/ItemModel
# Definition of an item model for the ItemPick and BoxPick components

# Required
string type

# Supported types (depending on component)
string UNKNOWN=UNKNOWN
string RECTANGLE=RECTANGLE

# Only one of those required depending on the selected type
# In case of unknown type, these values defines an optional bounding box for the item
RangeBox unknown
RangeRectangle rectangle

================================================================================
MSG: rc_reason_msgs/RangeBox
# Definition of a box with minimum and maximum dimensions

Box min_dimensions
Box max_dimensions

================================================================================
MSG: rc_reason_msgs/RangeRectangle
# Definition of a rectangle with minimum and maximum dimensions

Rectangle min_dimensions
Rectangle max_dimensions

================================================================================
MSG: rc_reason_msgs/Rectangle
# Definition of a rectangle

float64 x
float64 y

================================================================================
MSG: rc_reason_msgs/CollisionDetection
string gripper_id

geometry_msgs/Point pre_grasp_offset
"""
  __slots__ = ['pose_frame','region_of_interest_id','load_carrier_id','load_carrier_compartment','item_models','suction_surface_length','suction_surface_width','robot_pose','collision_detection']
  _slot_types = ['string','string','string','rc_reason_msgs/Compartment','rc_reason_msgs/ItemModel[]','float64','float64','geometry_msgs/Pose','rc_reason_msgs/CollisionDetection']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       pose_frame,region_of_interest_id,load_carrier_id,load_carrier_compartment,item_models,suction_surface_length,suction_surface_width,robot_pose,collision_detection

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ComputeGraspsRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.pose_frame is None:
        self.pose_frame = ''
      if self.region_of_interest_id is None:
        self.region_of_interest_id = ''
      if self.load_carrier_id is None:
        self.load_carrier_id = ''
      if self.load_carrier_compartment is None:
        self.load_carrier_compartment = rc_reason_msgs.msg.Compartment()
      if self.item_models is None:
        self.item_models = []
      if self.suction_surface_length is None:
        self.suction_surface_length = 0.
      if self.suction_surface_width is None:
        self.suction_surface_width = 0.
      if self.robot_pose is None:
        self.robot_pose = geometry_msgs.msg.Pose()
      if self.collision_detection is None:
        self.collision_detection = rc_reason_msgs.msg.CollisionDetection()
    else:
      self.pose_frame = ''
      self.region_of_interest_id = ''
      self.load_carrier_id = ''
      self.load_carrier_compartment = rc_reason_msgs.msg.Compartment()
      self.item_models = []
      self.suction_surface_length = 0.
      self.suction_surface_width = 0.
      self.robot_pose = geometry_msgs.msg.Pose()
      self.collision_detection = rc_reason_msgs.msg.CollisionDetection()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.pose_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.region_of_interest_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.load_carrier_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_10d().pack(_x.load_carrier_compartment.pose.position.x, _x.load_carrier_compartment.pose.position.y, _x.load_carrier_compartment.pose.position.z, _x.load_carrier_compartment.pose.orientation.x, _x.load_carrier_compartment.pose.orientation.y, _x.load_carrier_compartment.pose.orientation.z, _x.load_carrier_compartment.pose.orientation.w, _x.load_carrier_compartment.box.x, _x.load_carrier_compartment.box.y, _x.load_carrier_compartment.box.z))
      length = len(self.item_models)
      buff.write(_struct_I.pack(length))
      for val1 in self.item_models:
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v1 = val1.unknown
        _v2 = _v1.min_dimensions
        _x = _v2
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v3 = _v1.max_dimensions
        _x = _v3
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v4 = val1.rectangle
        _v5 = _v4.min_dimensions
        _x = _v5
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v6 = _v4.max_dimensions
        _x = _v6
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
      _x = self
      buff.write(_get_struct_9d().pack(_x.suction_surface_length, _x.suction_surface_width, _x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w))
      _x = self.collision_detection.gripper_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3d().pack(_x.collision_detection.pre_grasp_offset.x, _x.collision_detection.pre_grasp_offset.y, _x.collision_detection.pre_grasp_offset.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.load_carrier_compartment is None:
        self.load_carrier_compartment = rc_reason_msgs.msg.Compartment()
      if self.item_models is None:
        self.item_models = None
      if self.robot_pose is None:
        self.robot_pose = geometry_msgs.msg.Pose()
      if self.collision_detection is None:
        self.collision_detection = rc_reason_msgs.msg.CollisionDetection()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose_frame = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.pose_frame = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.region_of_interest_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.region_of_interest_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.load_carrier_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.load_carrier_id = str[start:end]
      _x = self
      start = end
      end += 80
      (_x.load_carrier_compartment.pose.position.x, _x.load_carrier_compartment.pose.position.y, _x.load_carrier_compartment.pose.position.z, _x.load_carrier_compartment.pose.orientation.x, _x.load_carrier_compartment.pose.orientation.y, _x.load_carrier_compartment.pose.orientation.z, _x.load_carrier_compartment.pose.orientation.w, _x.load_carrier_compartment.box.x, _x.load_carrier_compartment.box.y, _x.load_carrier_compartment.box.z,) = _get_struct_10d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.item_models = []
      for i in range(0, length):
        val1 = rc_reason_msgs.msg.ItemModel()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.type = str[start:end]
        _v7 = val1.unknown
        _v8 = _v7.min_dimensions
        _x = _v8
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v9 = _v7.max_dimensions
        _x = _v9
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v10 = val1.rectangle
        _v11 = _v10.min_dimensions
        _x = _v11
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v12 = _v10.max_dimensions
        _x = _v12
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        self.item_models.append(val1)
      _x = self
      start = end
      end += 72
      (_x.suction_surface_length, _x.suction_surface_width, _x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w,) = _get_struct_9d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.collision_detection.gripper_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.collision_detection.gripper_id = str[start:end]
      _x = self
      start = end
      end += 24
      (_x.collision_detection.pre_grasp_offset.x, _x.collision_detection.pre_grasp_offset.y, _x.collision_detection.pre_grasp_offset.z,) = _get_struct_3d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.pose_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.region_of_interest_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.load_carrier_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_10d().pack(_x.load_carrier_compartment.pose.position.x, _x.load_carrier_compartment.pose.position.y, _x.load_carrier_compartment.pose.position.z, _x.load_carrier_compartment.pose.orientation.x, _x.load_carrier_compartment.pose.orientation.y, _x.load_carrier_compartment.pose.orientation.z, _x.load_carrier_compartment.pose.orientation.w, _x.load_carrier_compartment.box.x, _x.load_carrier_compartment.box.y, _x.load_carrier_compartment.box.z))
      length = len(self.item_models)
      buff.write(_struct_I.pack(length))
      for val1 in self.item_models:
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v13 = val1.unknown
        _v14 = _v13.min_dimensions
        _x = _v14
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v15 = _v13.max_dimensions
        _x = _v15
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v16 = val1.rectangle
        _v17 = _v16.min_dimensions
        _x = _v17
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v18 = _v16.max_dimensions
        _x = _v18
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
      _x = self
      buff.write(_get_struct_9d().pack(_x.suction_surface_length, _x.suction_surface_width, _x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w))
      _x = self.collision_detection.gripper_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3d().pack(_x.collision_detection.pre_grasp_offset.x, _x.collision_detection.pre_grasp_offset.y, _x.collision_detection.pre_grasp_offset.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.load_carrier_compartment is None:
        self.load_carrier_compartment = rc_reason_msgs.msg.Compartment()
      if self.item_models is None:
        self.item_models = None
      if self.robot_pose is None:
        self.robot_pose = geometry_msgs.msg.Pose()
      if self.collision_detection is None:
        self.collision_detection = rc_reason_msgs.msg.CollisionDetection()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose_frame = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.pose_frame = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.region_of_interest_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.region_of_interest_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.load_carrier_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.load_carrier_id = str[start:end]
      _x = self
      start = end
      end += 80
      (_x.load_carrier_compartment.pose.position.x, _x.load_carrier_compartment.pose.position.y, _x.load_carrier_compartment.pose.position.z, _x.load_carrier_compartment.pose.orientation.x, _x.load_carrier_compartment.pose.orientation.y, _x.load_carrier_compartment.pose.orientation.z, _x.load_carrier_compartment.pose.orientation.w, _x.load_carrier_compartment.box.x, _x.load_carrier_compartment.box.y, _x.load_carrier_compartment.box.z,) = _get_struct_10d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.item_models = []
      for i in range(0, length):
        val1 = rc_reason_msgs.msg.ItemModel()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.type = str[start:end]
        _v19 = val1.unknown
        _v20 = _v19.min_dimensions
        _x = _v20
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v21 = _v19.max_dimensions
        _x = _v21
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v22 = val1.rectangle
        _v23 = _v22.min_dimensions
        _x = _v23
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v24 = _v22.max_dimensions
        _x = _v24
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        self.item_models.append(val1)
      _x = self
      start = end
      end += 72
      (_x.suction_surface_length, _x.suction_surface_width, _x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w,) = _get_struct_9d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.collision_detection.gripper_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.collision_detection.gripper_id = str[start:end]
      _x = self
      start = end
      end += 24
      (_x.collision_detection.pre_grasp_offset.x, _x.collision_detection.pre_grasp_offset.y, _x.collision_detection.pre_grasp_offset.z,) = _get_struct_3d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_10d = None
def _get_struct_10d():
    global _struct_10d
    if _struct_10d is None:
        _struct_10d = struct.Struct("<10d")
    return _struct_10d
_struct_2d = None
def _get_struct_2d():
    global _struct_2d
    if _struct_2d is None:
        _struct_2d = struct.Struct("<2d")
    return _struct_2d
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_9d = None
def _get_struct_9d():
    global _struct_9d
    if _struct_9d is None:
        _struct_9d = struct.Struct("<9d")
    return _struct_9d
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rc_reason_msgs/ComputeGraspsResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import geometry_msgs.msg
import rc_common_msgs.msg
import rc_reason_msgs.msg
import std_msgs.msg

class ComputeGraspsResponse(genpy.Message):
  _md5sum = "3777582c6793e3d633f4fdb94eadf955"
  _type = "rc_reason_msgs/ComputeGraspsResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """
time timestamp

Item[] items

LoadCarrier[] load_carriers

SuctionGrasp[] grasps

rc_common_msgs/ReturnCode return_code


================================================================================
MSG: rc_reason_msgs/Item
# Definition of a detected item

string uuid

# Contains uuids of grasps on this object (if requested)
string[] grasp_uuids

string type

# Types
string RECTANGLE=RECTANGLE

# if type==RECTANGLE
Rectangle rectangle

# The pose of the item
geometry_msgs/PoseStamped pose

================================================================================
MSG: rc_reason_msgs/Rectangle
# Definition of a rectangle

float64 x
float64 y

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: rc_reason_msgs/LoadCarrier
# This represents a detected load carrier by its geometry and its pose

string id

# Optional. The load carrier rim model. The only supported value is STANDARD
string type

# Required
Box outer_dimensions

# Required
Box inner_dimensions

# Optional. If not provided, the rim thickness is computed from the outer and inner dimensions
Rectangle rim_thickness

# Optional. Height of the rim step for rims with an L-profile.
float64 rim_step_height

# Optional. Length of the rim ledge in x and y direction. This requires rim_thickness to be set.
Rectangle rim_ledge

# Optional. Height of the open side of a 3-sided load carrier measured from the outer bottom.
float64 height_open_side

geometry_msgs/PoseStamped pose

# True if a detected load carrier is overfilled. Ignored on setting load carrier.
bool overfilled

================================================================================
MSG: rc_reason_msgs/Box
# Definition of a box

float64 x
float64 y
float64 z

================================================================================
MSG: rc_reason_msgs/SuctionGrasp
# Definition of a suction grasp for the ItemPick component

string uuid

# Optional
string item_uuid

# The grasp orientation is defined such that:
# - the z axis is the normal of the surface at the grasp position
# - the x axis is directed along the direction of maximum elongation of the surface
# - the y axis is selected to form a right-handed coordinate system
geometry_msgs/PoseStamped pose

# Optional. The quality of the grasp (between 0 and 1)
float64 quality

# Optional. The axis lengths of the biggest ellipse inscribed on the suction surface
float64 max_suction_surface_length
float64 max_suction_surface_width

================================================================================
MSG: rc_common_msgs/ReturnCode
# This message shall be used in the response of services as a field called return_code.
# Confer to ReturnCodeConsts message for commonly used return code definitions.

# return codes
# >=0 - success
# < 0 - failure

# return code
int16 value

# return message
string message
"""
  __slots__ = ['timestamp','items','load_carriers','grasps','return_code']
  _slot_types = ['time','rc_reason_msgs/Item[]','rc_reason_msgs/LoadCarrier[]','rc_reason_msgs/SuctionGrasp[]','rc_common_msgs/ReturnCode']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,items,load_carriers,grasps,return_code

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ComputeGraspsResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.items is None:
        self.items = []
      if self.load_carriers is None:
        self.load_carriers = []
      if self.grasps is None:
        self.grasps = []
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
    else:
      self.timestamp = genpy.Time()
      self.items = []
      self.load_carriers = []
      self.grasps = []
      self.return_code = rc_common_msgs.msg.ReturnCode()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2I().pack(_x.timestamp.secs, _x.timestamp.nsecs))
      length = len(self.items)
      buff.write(_struct_I.pack(length))
      for val1 in self.items:
        _x = val1.uuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.grasp_uuids)
        buff.write(_struct_I.pack(length))
        for val2 in val1.grasp_uuids:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          buff.write(struct.Struct('<I%ss'%length).pack(length, val2))
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v25 = val1.rectangle
        _x = _v25
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v26 = val1.pose
        _v27 = _v26.header
        _x = _v27.seq
        buff.write(_get_struct_I().pack(_x))
        _v28 = _v27.stamp
        _x = _v28
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v27.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v29 = _v26.pose
        _v30 = _v29.position
        _x = _v30
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v31 = _v29.orientation
        _x = _v31
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
      length = len(self.load_carriers)
      buff.write(_struct_I.pack(length))
      for val1 in self.load_carriers:
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v32 = val1.outer_dimensions
        _x = _v32
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v33 = val1.inner_dimensions
        _x = _v33
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v34 = val1.rim_thickness
        _x = _v34
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _x = val1.rim_step_height
        buff.write(_get_struct_d().pack(_x))
        _v35 = val1.rim_ledge
        _x = _v35
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _x = val1.height_open_side
        buff.write(_get_struct_d().pack(_x))
        _v36 = val1.pose
        _v37 = _v36.header
        _x = _v37.seq
        buff.write(_get_struct_I().pack(_x))
        _v38 = _v37.stamp
        _x = _v38
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v37.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v39 = _v36.pose
        _v40 = _v39.position
        _x = _v40
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v41 = _v39.orientation
        _x = _v41
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.overfilled
        buff.write(_get_struct_B().pack(_x))
      length = len(self.grasps)
      buff.write(_struct_I.pack(length))
      for val1 in self.grasps:
        _x = val1.uuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.item_uuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v42 = val1.pose
        _v43 = _v42.header
        _x = _v43.seq
        buff.write(_get_struct_I().pack(_x))
        _v44 = _v43.stamp
        _x = _v44
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v43.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v45 = _v42.pose
        _v46 = _v45.position
        _x = _v46
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v47 = _v45.orientation
        _x = _v47
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_get_struct_3d().pack(_x.quality, _x.max_suction_surface_length, _x.max_suction_surface_width))
      _x = self.return_code.value
      buff.write(_get_struct_h().pack(_x))
      _x = self.return_code.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.items is None:
        self.items = None
      if self.load_carriers is None:
        self.load_carriers = None
      if self.grasps is None:
        self.grasps = None
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.items = []
      for i in range(0, length):
        val1 = rc_reason_msgs.msg.Item()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.uuid = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.uuid = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.grasp_uuids = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2 = str[start:end]
          val1.grasp_uuids.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.type = str[start:end]
        _v48 = val1.rectangle
        _x = _v48
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v49 = val1.pose
        _v50 = _v49.header
        start = end
        end += 4
        (_v50.seq,) = _get_struct_I().unpack(str[start:end])
        _v51 = _v50.stamp
        _x = _v51
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v50.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v50.frame_id = str[start:end]
        _v52 = _v49.pose
        _v53 = _v52.position
        _x = _v53
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v54 = _v52.orientation
        _x = _v54
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        self.items.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.load_carriers = []
      for i in range(0, length):
        val1 = rc_reason_msgs.msg.LoadCarrier()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.type = str[start:end]
        _v55 = val1.outer_dimensions
        _x = _v55
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v56 = val1.inner_dimensions
        _x = _v56
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v57 = val1.rim_thickness
        _x = _v57
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        start = end
        end += 8
        (val1.rim_step_height,) = _get_struct_d().unpack(str[start:end])
        _v58 = val1.rim_ledge
        _x = _v58
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        start = end
        end += 8
        (val1.height_open_side,) = _get_struct_d().unpack(str[start:end])
        _v59 = val1.pose
        _v60 = _v59.header
        start = end
        end += 4
        (_v60.seq,) = _get_struct_I().unpack(str[start:end])
        _v61 = _v60.stamp
        _x = _v61
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v60.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v60.frame_id = str[start:end]
        _v62 = _v59.pose
        _v63 = _v62.position
        _x = _v63
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v64 = _v62.orientation
        _x = _v64
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 1
        (val1.overfilled,) = _get_struct_B().unpack(str[start:end])
        val1.overfilled = bool(val1.overfilled)
        self.load_carriers.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.grasps = []
      for i in range(0, length):
        val1 = rc_reason_msgs.msg.SuctionGrasp()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.uuid = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.uuid = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.item_uuid = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.item_uuid = str[start:end]
        _v65 = val1.pose
        _v66 = _v65.header
        start = end
        end += 4
        (_v66.seq,) = _get_struct_I().unpack(str[start:end])
        _v67 = _v66.stamp
        _x = _v67
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v66.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v66.frame_id = str[start:end]
        _v68 = _v65.pose
        _v69 = _v68.position
        _x = _v69
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v70 = _v68.orientation
        _x = _v70
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _x = val1
        start = end
        end += 24
        (_x.quality, _x.max_suction_surface_length, _x.max_suction_surface_width,) = _get_struct_3d().unpack(str[start:end])
        self.grasps.append(val1)
      start = end
      end += 2
      (self.return_code.value,) = _get_struct_h().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.return_code.message = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.return_code.message = str[start:end]
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2I().pack(_x.timestamp.secs, _x.timestamp.nsecs))
      length = len(self.items)
      buff.write(_struct_I.pack(length))
      for val1 in self.items:
        _x = val1.uuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.grasp_uuids)
        buff.write(_struct_I.pack(length))
        for val2 in val1.grasp_uuids:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          buff.write(struct.Struct('<I%ss'%length).pack(length, val2))
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v71 = val1.rectangle
        _x = _v71
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v72 = val1.pose
        _v73 = _v72.header
        _x = _v73.seq
        buff.write(_get_struct_I().pack(_x))
        _v74 = _v73.stamp
        _x = _v74
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v73.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v75 = _v72.pose
        _v76 = _v75.position
        _x = _v76
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v77 = _v75.orientation
        _x = _v77
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
      length = len(self.load_carriers)
      buff.write(_struct_I.pack(length))
      for val1 in self.load_carriers:
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v78 = val1.outer_dimensions
        _x = _v78
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v79 = val1.inner_dimensions
        _x = _v79
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v80 = val1.rim_thickness
        _x = _v80
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _x = val1.rim_step_height
        buff.write(_get_struct_d().pack(_x))
        _v81 = val1.rim_ledge
        _x = _v81
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _x = val1.height_open_side
        buff.write(_get_struct_d().pack(_x))
        _v82 = val1.pose
        _v83 = _v82.header
        _x = _v83.seq
        buff.write(_get_struct_I().pack(_x))
        _v84 = _v83.stamp
        _x = _v84
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v83.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v85 = _v82.pose
        _v86 = _v85.position
        _x = _v86
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v87 = _v85.orientation
        _x = _v87
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.overfilled
        buff.write(_get_struct_B().pack(_x))
      length = len(self.grasps)
      buff.write(_struct_I.pack(length))
      for val1 in self.grasps:
        _x = val1.uuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.item_uuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v88 = val1.pose
        _v89 = _v88.header
        _x = _v89.seq
        buff.write(_get_struct_I().pack(_x))
        _v90 = _v89.stamp
        _x = _v90
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v89.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v91 = _v88.pose
        _v92 = _v91.position
        _x = _v92
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v93 = _v91.orientation
        _x = _v93
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_get_struct_3d().pack(_x.quality, _x.max_suction_surface_length, _x.max_suction_surface_width))
      _x = self.return_code.value
      buff.write(_get_struct_h().pack(_x))
      _x = self.return_code.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.items is None:
        self.items = None
      if self.load_carriers is None:
        self.load_carriers = None
      if self.grasps is None:
        self.grasps = None
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.items = []
      for i in range(0, length):
        val1 = rc_reason_msgs.msg.Item()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.uuid = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.uuid = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.grasp_uuids = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2 = str[start:end]
          val1.grasp_uuids.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.type = str[start:end]
        _v94 = val1.rectangle
        _x = _v94
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v95 = val1.pose
        _v96 = _v95.header
        start = end
        end += 4
        (_v96.seq,) = _get_struct_I().unpack(str[start:end])
        _v97 = _v96.stamp
        _x = _v97
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v96.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v96.frame_id = str[start:end]
        _v98 = _v95.pose
        _v99 = _v98.position
        _x = _v99
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v100 = _v98.orientation
        _x = _v100
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        self.items.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.load_carriers = []
      for i in range(0, length):
        val1 = rc_reason_msgs.msg.LoadCarrier()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.type = str[start:end]
        _v101 = val1.outer_dimensions
        _x = _v101
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v102 = val1.inner_dimensions
        _x = _v102
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v103 = val1.rim_thickness
        _x = _v103
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        start = end
        end += 8
        (val1.rim_step_height,) = _get_struct_d().unpack(str[start:end])
        _v104 = val1.rim_ledge
        _x = _v104
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        start = end
        end += 8
        (val1.height_open_side,) = _get_struct_d().unpack(str[start:end])
        _v105 = val1.pose
        _v106 = _v105.header
        start = end
        end += 4
        (_v106.seq,) = _get_struct_I().unpack(str[start:end])
        _v107 = _v106.stamp
        _x = _v107
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v106.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v106.frame_id = str[start:end]
        _v108 = _v105.pose
        _v109 = _v108.position
        _x = _v109
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v110 = _v108.orientation
        _x = _v110
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 1
        (val1.overfilled,) = _get_struct_B().unpack(str[start:end])
        val1.overfilled = bool(val1.overfilled)
        self.load_carriers.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.grasps = []
      for i in range(0, length):
        val1 = rc_reason_msgs.msg.SuctionGrasp()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.uuid = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.uuid = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.item_uuid = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.item_uuid = str[start:end]
        _v111 = val1.pose
        _v112 = _v111.header
        start = end
        end += 4
        (_v112.seq,) = _get_struct_I().unpack(str[start:end])
        _v113 = _v112.stamp
        _x = _v113
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v112.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v112.frame_id = str[start:end]
        _v114 = _v111.pose
        _v115 = _v114.position
        _x = _v115
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v116 = _v114.orientation
        _x = _v116
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _x = val1
        start = end
        end += 24
        (_x.quality, _x.max_suction_surface_length, _x.max_suction_surface_width,) = _get_struct_3d().unpack(str[start:end])
        self.grasps.append(val1)
      start = end
      end += 2
      (self.return_code.value,) = _get_struct_h().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.return_code.message = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.return_code.message = str[start:end]
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_2d = None
def _get_struct_2d():
    global _struct_2d
    if _struct_2d is None:
        _struct_2d = struct.Struct("<2d")
    return _struct_2d
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_d = None
def _get_struct_d():
    global _struct_d
    if _struct_d is None:
        _struct_d = struct.Struct("<d")
    return _struct_d
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
class ComputeGrasps(object):
  _type          = 'rc_reason_msgs/ComputeGrasps'
  _md5sum = '1dcd1cb063a53b42b2ed9a9acfdb19db'
  _request_class  = ComputeGraspsRequest
  _response_class = ComputeGraspsResponse
