# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rc_reason_msgs/DetectFillingLevelRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import rc_reason_msgs.msg

class DetectFillingLevelRequest(genpy.Message):
  _md5sum = "b1a21f6f9dda8c395a4c47797b516d50"
  _type = "rc_reason_msgs/DetectFillingLevelRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Description: Triggers the detection of the given load carriers and their filling level.

# Required. Pose frame for output poses (valid values are camera and external)
string pose_frame

# Optional
string region_of_interest_id

# Optional
string region_of_interest_2d_id

# Required
string[] load_carrier_ids

# Required only if reference frame = external and sensor is robot-mounted
geometry_msgs/Pose robot_pose

# Number of filling level cells to split detected load carriers
GridSize filling_level_cell_count


================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: rc_reason_msgs/GridSize
uint32 x
uint32 y
"""
  __slots__ = ['pose_frame','region_of_interest_id','region_of_interest_2d_id','load_carrier_ids','robot_pose','filling_level_cell_count']
  _slot_types = ['string','string','string','string[]','geometry_msgs/Pose','rc_reason_msgs/GridSize']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       pose_frame,region_of_interest_id,region_of_interest_2d_id,load_carrier_ids,robot_pose,filling_level_cell_count

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(DetectFillingLevelRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.pose_frame is None:
        self.pose_frame = ''
      if self.region_of_interest_id is None:
        self.region_of_interest_id = ''
      if self.region_of_interest_2d_id is None:
        self.region_of_interest_2d_id = ''
      if self.load_carrier_ids is None:
        self.load_carrier_ids = []
      if self.robot_pose is None:
        self.robot_pose = geometry_msgs.msg.Pose()
      if self.filling_level_cell_count is None:
        self.filling_level_cell_count = rc_reason_msgs.msg.GridSize()
    else:
      self.pose_frame = ''
      self.region_of_interest_id = ''
      self.region_of_interest_2d_id = ''
      self.load_carrier_ids = []
      self.robot_pose = geometry_msgs.msg.Pose()
      self.filling_level_cell_count = rc_reason_msgs.msg.GridSize()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.pose_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.region_of_interest_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.region_of_interest_2d_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.load_carrier_ids)
      buff.write(_struct_I.pack(length))
      for val1 in self.load_carrier_ids:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      _x = self
      buff.write(_get_struct_7d2I().pack(_x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w, _x.filling_level_cell_count.x, _x.filling_level_cell_count.y))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.robot_pose is None:
        self.robot_pose = geometry_msgs.msg.Pose()
      if self.filling_level_cell_count is None:
        self.filling_level_cell_count = rc_reason_msgs.msg.GridSize()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose_frame = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.pose_frame = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.region_of_interest_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.region_of_interest_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.region_of_interest_2d_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.region_of_interest_2d_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.load_carrier_ids = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.load_carrier_ids.append(val1)
      _x = self
      start = end
      end += 64
      (_x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w, _x.filling_level_cell_count.x, _x.filling_level_cell_count.y,) = _get_struct_7d2I().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.pose_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.region_of_interest_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.region_of_interest_2d_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.load_carrier_ids)
      buff.write(_struct_I.pack(length))
      for val1 in self.load_carrier_ids:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      _x = self
      buff.write(_get_struct_7d2I().pack(_x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w, _x.filling_level_cell_count.x, _x.filling_level_cell_count.y))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.robot_pose is None:
        self.robot_pose = geometry_msgs.msg.Pose()
      if self.filling_level_cell_count is None:
        self.filling_level_cell_count = rc_reason_msgs.msg.GridSize()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose_frame = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.pose_frame = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.region_of_interest_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.region_of_interest_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.region_of_interest_2d_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.region_of_interest_2d_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.load_carrier_ids = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.load_carrier_ids.append(val1)
      _x = self
      start = end
      end += 64
      (_x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w, _x.filling_level_cell_count.x, _x.filling_level_cell_count.y,) = _get_struct_7d2I().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_7d2I = None
def _get_struct_7d2I():
    global _struct_7d2I
    if _struct_7d2I is None:
        _struct_7d2I = struct.Struct("<7d2I")
    return _struct_7d2I
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rc_reason_msgs/DetectFillingLevelResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import geometry_msgs.msg
import rc_common_msgs.msg
import rc_reason_msgs.msg
import std_msgs.msg

class DetectFillingLevelResponse(genpy.Message):
  _md5sum = "4f01411cd4f86a2592ff3844bc13befa"
  _type = "rc_reason_msgs/DetectFillingLevelResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """
time timestamp

LoadCarrierWithFillingLevel[] load_carriers

rc_common_msgs/ReturnCode return_code


================================================================================
MSG: rc_reason_msgs/LoadCarrierWithFillingLevel
# This represents a detected load carrier with it's filling level

string id

# Optional. The load carrier rim model. The only supported value is STANDARD
string type

# Required
Box outer_dimensions

# Required
Box inner_dimensions

# Optional. If not provided, the rim thickness is computed from the outer and inner dimensions
Rectangle rim_thickness

# Optional. Height of the rim step for rims with an L-profile.
float64 rim_step_height

# Optional. Length of the rim ledge in x and y direction. This requires rim_thickness to be set.
Rectangle rim_ledge

# Optional. Height of the open side of a 3-sided load carrier measured from the outer bottom.
float64 height_open_side

geometry_msgs/PoseStamped pose

# True if a detected load carrier is overfilled. Ignored on setting load carrier.
bool overfilled

# Filling level of the whole load carrier
CellFillingLevel overall_filling_level

# Filling level of each load carrier cell
CellFillingLevel[] cells_filling_levels

GridSize filling_level_cell_count

================================================================================
MSG: rc_reason_msgs/Box
# Definition of a box

float64 x
float64 y
float64 z

================================================================================
MSG: rc_reason_msgs/Rectangle
# Definition of a rectangle

float64 x
float64 y

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: rc_reason_msgs/CellFillingLevel
# Dimensions of the 2D cell in meters
Rectangle cell_size

# Position of the cell center in meters (either in camera or external pose frame)
# The z-coordinate is on the level of the load carrier rim
geometry_msgs/Point cell_position

# Filling level of the cell in percent (100% represents a full cell)
RangeValue level_in_percent

# Free space of the cell in meters (how much space is left until the cell is full)
RangeValue level_free_in_meters

# Represents the percentage of valid pixels in this cell. Between 0 and 1 
float64 coverage

================================================================================
MSG: rc_reason_msgs/RangeValue
float64 min
float64 max
float64 mean

================================================================================
MSG: rc_reason_msgs/GridSize
uint32 x
uint32 y

================================================================================
MSG: rc_common_msgs/ReturnCode
# This message shall be used in the response of services as a field called return_code.
# Confer to ReturnCodeConsts message for commonly used return code definitions.

# return codes
# >=0 - success
# < 0 - failure

# return code
int16 value

# return message
string message
"""
  __slots__ = ['timestamp','load_carriers','return_code']
  _slot_types = ['time','rc_reason_msgs/LoadCarrierWithFillingLevel[]','rc_common_msgs/ReturnCode']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,load_carriers,return_code

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(DetectFillingLevelResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.load_carriers is None:
        self.load_carriers = []
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
    else:
      self.timestamp = genpy.Time()
      self.load_carriers = []
      self.return_code = rc_common_msgs.msg.ReturnCode()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2I().pack(_x.timestamp.secs, _x.timestamp.nsecs))
      length = len(self.load_carriers)
      buff.write(_struct_I.pack(length))
      for val1 in self.load_carriers:
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v1 = val1.outer_dimensions
        _x = _v1
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v2 = val1.inner_dimensions
        _x = _v2
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v3 = val1.rim_thickness
        _x = _v3
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _x = val1.rim_step_height
        buff.write(_get_struct_d().pack(_x))
        _v4 = val1.rim_ledge
        _x = _v4
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _x = val1.height_open_side
        buff.write(_get_struct_d().pack(_x))
        _v5 = val1.pose
        _v6 = _v5.header
        _x = _v6.seq
        buff.write(_get_struct_I().pack(_x))
        _v7 = _v6.stamp
        _x = _v7
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v6.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v8 = _v5.pose
        _v9 = _v8.position
        _x = _v9
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v10 = _v8.orientation
        _x = _v10
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.overfilled
        buff.write(_get_struct_B().pack(_x))
        _v11 = val1.overall_filling_level
        _v12 = _v11.cell_size
        _x = _v12
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v13 = _v11.cell_position
        _x = _v13
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v14 = _v11.level_in_percent
        _x = _v14
        buff.write(_get_struct_3d().pack(_x.min, _x.max, _x.mean))
        _v15 = _v11.level_free_in_meters
        _x = _v15
        buff.write(_get_struct_3d().pack(_x.min, _x.max, _x.mean))
        _x = _v11.coverage
        buff.write(_get_struct_d().pack(_x))
        length = len(val1.cells_filling_levels)
        buff.write(_struct_I.pack(length))
        for val2 in val1.cells_filling_levels:
          _v16 = val2.cell_size
          _x = _v16
          buff.write(_get_struct_2d().pack(_x.x, _x.y))
          _v17 = val2.cell_position
          _x = _v17
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v18 = val2.level_in_percent
          _x = _v18
          buff.write(_get_struct_3d().pack(_x.min, _x.max, _x.mean))
          _v19 = val2.level_free_in_meters
          _x = _v19
          buff.write(_get_struct_3d().pack(_x.min, _x.max, _x.mean))
          _x = val2.coverage
          buff.write(_get_struct_d().pack(_x))
        _v20 = val1.filling_level_cell_count
        _x = _v20
        buff.write(_get_struct_2I().pack(_x.x, _x.y))
      _x = self.return_code.value
      buff.write(_get_struct_h().pack(_x))
      _x = self.return_code.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.load_carriers is None:
        self.load_carriers = None
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.load_carriers = []
      for i in range(0, length):
        val1 = rc_reason_msgs.msg.LoadCarrierWithFillingLevel()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.type = str[start:end]
        _v21 = val1.outer_dimensions
        _x = _v21
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v22 = val1.inner_dimensions
        _x = _v22
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v23 = val1.rim_thickness
        _x = _v23
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        start = end
        end += 8
        (val1.rim_step_height,) = _get_struct_d().unpack(str[start:end])
        _v24 = val1.rim_ledge
        _x = _v24
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        start = end
        end += 8
        (val1.height_open_side,) = _get_struct_d().unpack(str[start:end])
        _v25 = val1.pose
        _v26 = _v25.header
        start = end
        end += 4
        (_v26.seq,) = _get_struct_I().unpack(str[start:end])
        _v27 = _v26.stamp
        _x = _v27
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v26.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v26.frame_id = str[start:end]
        _v28 = _v25.pose
        _v29 = _v28.position
        _x = _v29
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v30 = _v28.orientation
        _x = _v30
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 1
        (val1.overfilled,) = _get_struct_B().unpack(str[start:end])
        val1.overfilled = bool(val1.overfilled)
        _v31 = val1.overall_filling_level
        _v32 = _v31.cell_size
        _x = _v32
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v33 = _v31.cell_position
        _x = _v33
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v34 = _v31.level_in_percent
        _x = _v34
        start = end
        end += 24
        (_x.min, _x.max, _x.mean,) = _get_struct_3d().unpack(str[start:end])
        _v35 = _v31.level_free_in_meters
        _x = _v35
        start = end
        end += 24
        (_x.min, _x.max, _x.mean,) = _get_struct_3d().unpack(str[start:end])
        start = end
        end += 8
        (_v31.coverage,) = _get_struct_d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.cells_filling_levels = []
        for i in range(0, length):
          val2 = rc_reason_msgs.msg.CellFillingLevel()
          _v36 = val2.cell_size
          _x = _v36
          start = end
          end += 16
          (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
          _v37 = val2.cell_position
          _x = _v37
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v38 = val2.level_in_percent
          _x = _v38
          start = end
          end += 24
          (_x.min, _x.max, _x.mean,) = _get_struct_3d().unpack(str[start:end])
          _v39 = val2.level_free_in_meters
          _x = _v39
          start = end
          end += 24
          (_x.min, _x.max, _x.mean,) = _get_struct_3d().unpack(str[start:end])
          start = end
          end += 8
          (val2.coverage,) = _get_struct_d().unpack(str[start:end])
          val1.cells_filling_levels.append(val2)
        _v40 = val1.filling_level_cell_count
        _x = _v40
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2I().unpack(str[start:end])
        self.load_carriers.append(val1)
      start = end
      end += 2
      (self.return_code.value,) = _get_struct_h().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.return_code.message = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.return_code.message = str[start:end]
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2I().pack(_x.timestamp.secs, _x.timestamp.nsecs))
      length = len(self.load_carriers)
      buff.write(_struct_I.pack(length))
      for val1 in self.load_carriers:
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v41 = val1.outer_dimensions
        _x = _v41
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v42 = val1.inner_dimensions
        _x = _v42
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v43 = val1.rim_thickness
        _x = _v43
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _x = val1.rim_step_height
        buff.write(_get_struct_d().pack(_x))
        _v44 = val1.rim_ledge
        _x = _v44
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _x = val1.height_open_side
        buff.write(_get_struct_d().pack(_x))
        _v45 = val1.pose
        _v46 = _v45.header
        _x = _v46.seq
        buff.write(_get_struct_I().pack(_x))
        _v47 = _v46.stamp
        _x = _v47
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v46.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v48 = _v45.pose
        _v49 = _v48.position
        _x = _v49
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v50 = _v48.orientation
        _x = _v50
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.overfilled
        buff.write(_get_struct_B().pack(_x))
        _v51 = val1.overall_filling_level
        _v52 = _v51.cell_size
        _x = _v52
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v53 = _v51.cell_position
        _x = _v53
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v54 = _v51.level_in_percent
        _x = _v54
        buff.write(_get_struct_3d().pack(_x.min, _x.max, _x.mean))
        _v55 = _v51.level_free_in_meters
        _x = _v55
        buff.write(_get_struct_3d().pack(_x.min, _x.max, _x.mean))
        _x = _v51.coverage
        buff.write(_get_struct_d().pack(_x))
        length = len(val1.cells_filling_levels)
        buff.write(_struct_I.pack(length))
        for val2 in val1.cells_filling_levels:
          _v56 = val2.cell_size
          _x = _v56
          buff.write(_get_struct_2d().pack(_x.x, _x.y))
          _v57 = val2.cell_position
          _x = _v57
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v58 = val2.level_in_percent
          _x = _v58
          buff.write(_get_struct_3d().pack(_x.min, _x.max, _x.mean))
          _v59 = val2.level_free_in_meters
          _x = _v59
          buff.write(_get_struct_3d().pack(_x.min, _x.max, _x.mean))
          _x = val2.coverage
          buff.write(_get_struct_d().pack(_x))
        _v60 = val1.filling_level_cell_count
        _x = _v60
        buff.write(_get_struct_2I().pack(_x.x, _x.y))
      _x = self.return_code.value
      buff.write(_get_struct_h().pack(_x))
      _x = self.return_code.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.load_carriers is None:
        self.load_carriers = None
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.load_carriers = []
      for i in range(0, length):
        val1 = rc_reason_msgs.msg.LoadCarrierWithFillingLevel()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.type = str[start:end]
        _v61 = val1.outer_dimensions
        _x = _v61
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v62 = val1.inner_dimensions
        _x = _v62
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v63 = val1.rim_thickness
        _x = _v63
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        start = end
        end += 8
        (val1.rim_step_height,) = _get_struct_d().unpack(str[start:end])
        _v64 = val1.rim_ledge
        _x = _v64
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        start = end
        end += 8
        (val1.height_open_side,) = _get_struct_d().unpack(str[start:end])
        _v65 = val1.pose
        _v66 = _v65.header
        start = end
        end += 4
        (_v66.seq,) = _get_struct_I().unpack(str[start:end])
        _v67 = _v66.stamp
        _x = _v67
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v66.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v66.frame_id = str[start:end]
        _v68 = _v65.pose
        _v69 = _v68.position
        _x = _v69
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v70 = _v68.orientation
        _x = _v70
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 1
        (val1.overfilled,) = _get_struct_B().unpack(str[start:end])
        val1.overfilled = bool(val1.overfilled)
        _v71 = val1.overall_filling_level
        _v72 = _v71.cell_size
        _x = _v72
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v73 = _v71.cell_position
        _x = _v73
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v74 = _v71.level_in_percent
        _x = _v74
        start = end
        end += 24
        (_x.min, _x.max, _x.mean,) = _get_struct_3d().unpack(str[start:end])
        _v75 = _v71.level_free_in_meters
        _x = _v75
        start = end
        end += 24
        (_x.min, _x.max, _x.mean,) = _get_struct_3d().unpack(str[start:end])
        start = end
        end += 8
        (_v71.coverage,) = _get_struct_d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.cells_filling_levels = []
        for i in range(0, length):
          val2 = rc_reason_msgs.msg.CellFillingLevel()
          _v76 = val2.cell_size
          _x = _v76
          start = end
          end += 16
          (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
          _v77 = val2.cell_position
          _x = _v77
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v78 = val2.level_in_percent
          _x = _v78
          start = end
          end += 24
          (_x.min, _x.max, _x.mean,) = _get_struct_3d().unpack(str[start:end])
          _v79 = val2.level_free_in_meters
          _x = _v79
          start = end
          end += 24
          (_x.min, _x.max, _x.mean,) = _get_struct_3d().unpack(str[start:end])
          start = end
          end += 8
          (val2.coverage,) = _get_struct_d().unpack(str[start:end])
          val1.cells_filling_levels.append(val2)
        _v80 = val1.filling_level_cell_count
        _x = _v80
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2I().unpack(str[start:end])
        self.load_carriers.append(val1)
      start = end
      end += 2
      (self.return_code.value,) = _get_struct_h().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.return_code.message = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.return_code.message = str[start:end]
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_2d = None
def _get_struct_2d():
    global _struct_2d
    if _struct_2d is None:
        _struct_2d = struct.Struct("<2d")
    return _struct_2d
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_d = None
def _get_struct_d():
    global _struct_d
    if _struct_d is None:
        _struct_d = struct.Struct("<d")
    return _struct_d
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
class DetectFillingLevel(object):
  _type          = 'rc_reason_msgs/DetectFillingLevel'
  _md5sum = 'ec0b5b970982dfa93cfd05c144e01a33'
  _request_class  = DetectFillingLevelRequest
  _response_class = DetectFillingLevelResponse
