# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rc_reason_msgs/SetRegionOfInterest3DRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import rc_reason_msgs.msg
import shape_msgs.msg
import std_msgs.msg

class SetRegionOfInterest3DRequest(genpy.Message):
  _md5sum = "7c2a6a75253c87de6a6fe77d26b13195"
  _type = "rc_reason_msgs/SetRegionOfInterest3DRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Description: Sets a 3D region of interest.

# Required
RegionOfInterest3D region_of_interest


================================================================================
MSG: rc_reason_msgs/RegionOfInterest3D
# Definition of a 3D region of interest

# Optional
string id

# Required
geometry_msgs/PoseStamped pose

shape_msgs/SolidPrimitive primitive

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: shape_msgs/SolidPrimitive
# Define box, sphere, cylinder, cone 
# All shapes are defined to have their bounding boxes centered around 0,0,0.

uint8 BOX=1
uint8 SPHERE=2
uint8 CYLINDER=3
uint8 CONE=4

# The type of the shape
uint8 type


# The dimensions of the shape
float64[] dimensions

# The meaning of the shape dimensions: each constant defines the index in the 'dimensions' array

# For the BOX type, the X, Y, and Z dimensions are the length of the corresponding
# sides of the box.
uint8 BOX_X=0
uint8 BOX_Y=1
uint8 BOX_Z=2


# For the SPHERE type, only one component is used, and it gives the radius of
# the sphere.
uint8 SPHERE_RADIUS=0


# For the CYLINDER and CONE types, the center line is oriented along
# the Z axis.  Therefore the CYLINDER_HEIGHT (CONE_HEIGHT) component
# of dimensions gives the height of the cylinder (cone).  The
# CYLINDER_RADIUS (CONE_RADIUS) component of dimensions gives the
# radius of the base of the cylinder (cone).  Cone and cylinder
# primitives are defined to be circular. The tip of the cone is
# pointing up, along +Z axis.

uint8 CYLINDER_HEIGHT=0
uint8 CYLINDER_RADIUS=1

uint8 CONE_HEIGHT=0
uint8 CONE_RADIUS=1
"""
  __slots__ = ['region_of_interest']
  _slot_types = ['rc_reason_msgs/RegionOfInterest3D']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       region_of_interest

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SetRegionOfInterest3DRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.region_of_interest is None:
        self.region_of_interest = rc_reason_msgs.msg.RegionOfInterest3D()
    else:
      self.region_of_interest = rc_reason_msgs.msg.RegionOfInterest3D()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.region_of_interest.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3I().pack(_x.region_of_interest.pose.header.seq, _x.region_of_interest.pose.header.stamp.secs, _x.region_of_interest.pose.header.stamp.nsecs))
      _x = self.region_of_interest.pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7dB().pack(_x.region_of_interest.pose.pose.position.x, _x.region_of_interest.pose.pose.position.y, _x.region_of_interest.pose.pose.position.z, _x.region_of_interest.pose.pose.orientation.x, _x.region_of_interest.pose.pose.orientation.y, _x.region_of_interest.pose.pose.orientation.z, _x.region_of_interest.pose.pose.orientation.w, _x.region_of_interest.primitive.type))
      length = len(self.region_of_interest.primitive.dimensions)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.region_of_interest.primitive.dimensions))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.region_of_interest is None:
        self.region_of_interest = rc_reason_msgs.msg.RegionOfInterest3D()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.region_of_interest.id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.region_of_interest.id = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.region_of_interest.pose.header.seq, _x.region_of_interest.pose.header.stamp.secs, _x.region_of_interest.pose.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.region_of_interest.pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.region_of_interest.pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 57
      (_x.region_of_interest.pose.pose.position.x, _x.region_of_interest.pose.pose.position.y, _x.region_of_interest.pose.pose.position.z, _x.region_of_interest.pose.pose.orientation.x, _x.region_of_interest.pose.pose.orientation.y, _x.region_of_interest.pose.pose.orientation.z, _x.region_of_interest.pose.pose.orientation.w, _x.region_of_interest.primitive.type,) = _get_struct_7dB().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.region_of_interest.primitive.dimensions = s.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.region_of_interest.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3I().pack(_x.region_of_interest.pose.header.seq, _x.region_of_interest.pose.header.stamp.secs, _x.region_of_interest.pose.header.stamp.nsecs))
      _x = self.region_of_interest.pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7dB().pack(_x.region_of_interest.pose.pose.position.x, _x.region_of_interest.pose.pose.position.y, _x.region_of_interest.pose.pose.position.z, _x.region_of_interest.pose.pose.orientation.x, _x.region_of_interest.pose.pose.orientation.y, _x.region_of_interest.pose.pose.orientation.z, _x.region_of_interest.pose.pose.orientation.w, _x.region_of_interest.primitive.type))
      length = len(self.region_of_interest.primitive.dimensions)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.region_of_interest.primitive.dimensions.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.region_of_interest is None:
        self.region_of_interest = rc_reason_msgs.msg.RegionOfInterest3D()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.region_of_interest.id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.region_of_interest.id = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.region_of_interest.pose.header.seq, _x.region_of_interest.pose.header.stamp.secs, _x.region_of_interest.pose.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.region_of_interest.pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.region_of_interest.pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 57
      (_x.region_of_interest.pose.pose.position.x, _x.region_of_interest.pose.pose.position.y, _x.region_of_interest.pose.pose.position.z, _x.region_of_interest.pose.pose.orientation.x, _x.region_of_interest.pose.pose.orientation.y, _x.region_of_interest.pose.pose.orientation.z, _x.region_of_interest.pose.pose.orientation.w, _x.region_of_interest.primitive.type,) = _get_struct_7dB().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.region_of_interest.primitive.dimensions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_7dB = None
def _get_struct_7dB():
    global _struct_7dB
    if _struct_7dB is None:
        _struct_7dB = struct.Struct("<7dB")
    return _struct_7dB
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rc_reason_msgs/SetRegionOfInterest3DResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import rc_common_msgs.msg

class SetRegionOfInterest3DResponse(genpy.Message):
  _md5sum = "89940768eec602f7650f8f061383e0f9"
  _type = "rc_reason_msgs/SetRegionOfInterest3DResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """
rc_common_msgs/ReturnCode return_code


================================================================================
MSG: rc_common_msgs/ReturnCode
# This message shall be used in the response of services as a field called return_code.
# Confer to ReturnCodeConsts message for commonly used return code definitions.

# return codes
# >=0 - success
# < 0 - failure

# return code
int16 value

# return message
string message
"""
  __slots__ = ['return_code']
  _slot_types = ['rc_common_msgs/ReturnCode']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       return_code

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SetRegionOfInterest3DResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
    else:
      self.return_code = rc_common_msgs.msg.ReturnCode()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.return_code.value
      buff.write(_get_struct_h().pack(_x))
      _x = self.return_code.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
      end = 0
      start = end
      end += 2
      (self.return_code.value,) = _get_struct_h().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.return_code.message = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.return_code.message = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.return_code.value
      buff.write(_get_struct_h().pack(_x))
      _x = self.return_code.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
      end = 0
      start = end
      end += 2
      (self.return_code.value,) = _get_struct_h().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.return_code.message = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.return_code.message = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
class SetRegionOfInterest3D(object):
  _type          = 'rc_reason_msgs/SetRegionOfInterest3D'
  _md5sum = '688101a7a4529805195007f48db988b2'
  _request_class  = SetRegionOfInterest3DRequest
  _response_class = SetRegionOfInterest3DResponse
