// Auto-generated. Do not edit!

// (in-package rc_reason_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Tag = require('./Tag.js');
let geometry_msgs = _finder('geometry_msgs');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class DetectedTag {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.tag = null;
      this.pose = null;
      this.instance_id = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('tag')) {
        this.tag = initObj.tag
      }
      else {
        this.tag = new Tag();
      }
      if (initObj.hasOwnProperty('pose')) {
        this.pose = initObj.pose
      }
      else {
        this.pose = new geometry_msgs.msg.PoseStamped();
      }
      if (initObj.hasOwnProperty('instance_id')) {
        this.instance_id = initObj.instance_id
      }
      else {
        this.instance_id = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type DetectedTag
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [tag]
    bufferOffset = Tag.serialize(obj.tag, buffer, bufferOffset);
    // Serialize message field [pose]
    bufferOffset = geometry_msgs.msg.PoseStamped.serialize(obj.pose, buffer, bufferOffset);
    // Serialize message field [instance_id]
    bufferOffset = _serializer.string(obj.instance_id, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type DetectedTag
    let len;
    let data = new DetectedTag(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [tag]
    data.tag = Tag.deserialize(buffer, bufferOffset);
    // Deserialize message field [pose]
    data.pose = geometry_msgs.msg.PoseStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [instance_id]
    data.instance_id = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += Tag.getMessageSize(object.tag);
    length += geometry_msgs.msg.PoseStamped.getMessageSize(object.pose);
    length += _getByteLength(object.instance_id);
    return length + 4;
  }

  static datatype() {
    // Returns string type for a message object
    return 'rc_reason_msgs/DetectedTag';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'e25266e546682b5df1d9b8cffa0c3741';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Representation of detected tag
    
    # Header
    std_msgs/Header header
    
    # Detected tag. The size will be set to the estimated tag size.
    Tag tag
    
    # 3D pose of the detected tag
    geometry_msgs/PoseStamped pose
    
    # Instance ID of the tag
    string instance_id
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: rc_reason_msgs/Tag
    # Tag definition
    
    # ID of the tag.
    # For april tags, it is <family>_<tag_id>.
    # Available april tag families: 16h5, 25h7, 25h9, 36h10, 36h11.
    # Example: april tag family 25h7, tag id 5: 25h7_5.
    # For QR codes, it the the data contained in the QR code.
    string id
    
    # Side length of the (quadratic) tag.
    float64 size
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new DetectedTag(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.tag !== undefined) {
      resolved.tag = Tag.Resolve(msg.tag)
    }
    else {
      resolved.tag = new Tag()
    }

    if (msg.pose !== undefined) {
      resolved.pose = geometry_msgs.msg.PoseStamped.Resolve(msg.pose)
    }
    else {
      resolved.pose = new geometry_msgs.msg.PoseStamped()
    }

    if (msg.instance_id !== undefined) {
      resolved.instance_id = msg.instance_id;
    }
    else {
      resolved.instance_id = ''
    }

    return resolved;
    }
};

module.exports = DetectedTag;
