// Auto-generated. Do not edit!

// (in-package rc_reason_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class Grasp {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.id = null;
      this.uuid = null;
      this.match_uuid = null;
      this.pose = null;
      this.priority = null;
      this.gripper_id = null;
      this.collision_checked = null;
    }
    else {
      if (initObj.hasOwnProperty('id')) {
        this.id = initObj.id
      }
      else {
        this.id = '';
      }
      if (initObj.hasOwnProperty('uuid')) {
        this.uuid = initObj.uuid
      }
      else {
        this.uuid = '';
      }
      if (initObj.hasOwnProperty('match_uuid')) {
        this.match_uuid = initObj.match_uuid
      }
      else {
        this.match_uuid = '';
      }
      if (initObj.hasOwnProperty('pose')) {
        this.pose = initObj.pose
      }
      else {
        this.pose = new geometry_msgs.msg.PoseStamped();
      }
      if (initObj.hasOwnProperty('priority')) {
        this.priority = initObj.priority
      }
      else {
        this.priority = 0;
      }
      if (initObj.hasOwnProperty('gripper_id')) {
        this.gripper_id = initObj.gripper_id
      }
      else {
        this.gripper_id = '';
      }
      if (initObj.hasOwnProperty('collision_checked')) {
        this.collision_checked = initObj.collision_checked
      }
      else {
        this.collision_checked = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Grasp
    // Serialize message field [id]
    bufferOffset = _serializer.string(obj.id, buffer, bufferOffset);
    // Serialize message field [uuid]
    bufferOffset = _serializer.string(obj.uuid, buffer, bufferOffset);
    // Serialize message field [match_uuid]
    bufferOffset = _serializer.string(obj.match_uuid, buffer, bufferOffset);
    // Serialize message field [pose]
    bufferOffset = geometry_msgs.msg.PoseStamped.serialize(obj.pose, buffer, bufferOffset);
    // Serialize message field [priority]
    bufferOffset = _serializer.int8(obj.priority, buffer, bufferOffset);
    // Serialize message field [gripper_id]
    bufferOffset = _serializer.string(obj.gripper_id, buffer, bufferOffset);
    // Serialize message field [collision_checked]
    bufferOffset = _serializer.bool(obj.collision_checked, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Grasp
    let len;
    let data = new Grasp(null);
    // Deserialize message field [id]
    data.id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [uuid]
    data.uuid = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [match_uuid]
    data.match_uuid = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [pose]
    data.pose = geometry_msgs.msg.PoseStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [priority]
    data.priority = _deserializer.int8(buffer, bufferOffset);
    // Deserialize message field [gripper_id]
    data.gripper_id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [collision_checked]
    data.collision_checked = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.id);
    length += _getByteLength(object.uuid);
    length += _getByteLength(object.match_uuid);
    length += geometry_msgs.msg.PoseStamped.getMessageSize(object.pose);
    length += _getByteLength(object.gripper_id);
    return length + 18;
  }

  static datatype() {
    // Returns string type for a message object
    return 'rc_reason_msgs/Grasp';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '8595403d3a247088bbfc60124fbc5000';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Definition of a grasp
    
    # user defined id (name)
    string id
    
    # unique id of this grasp
    string uuid
    
    # unique id of the match this grasp is associated to
    string match_uuid
    
    geometry_msgs/PoseStamped pose
    
    # Optional
    int8 priority
    
    string gripper_id
    
    bool collision_checked
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Grasp(null);
    if (msg.id !== undefined) {
      resolved.id = msg.id;
    }
    else {
      resolved.id = ''
    }

    if (msg.uuid !== undefined) {
      resolved.uuid = msg.uuid;
    }
    else {
      resolved.uuid = ''
    }

    if (msg.match_uuid !== undefined) {
      resolved.match_uuid = msg.match_uuid;
    }
    else {
      resolved.match_uuid = ''
    }

    if (msg.pose !== undefined) {
      resolved.pose = geometry_msgs.msg.PoseStamped.Resolve(msg.pose)
    }
    else {
      resolved.pose = new geometry_msgs.msg.PoseStamped()
    }

    if (msg.priority !== undefined) {
      resolved.priority = msg.priority;
    }
    else {
      resolved.priority = 0
    }

    if (msg.gripper_id !== undefined) {
      resolved.gripper_id = msg.gripper_id;
    }
    else {
      resolved.gripper_id = ''
    }

    if (msg.collision_checked !== undefined) {
      resolved.collision_checked = msg.collision_checked;
    }
    else {
      resolved.collision_checked = false
    }

    return resolved;
    }
};

module.exports = Grasp;
