// Auto-generated. Do not edit!

// (in-package rc_reason_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Box = require('./Box.js');
let Rectangle = require('./Rectangle.js');
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class LoadCarrierModel {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.id = null;
      this.type = null;
      this.outer_dimensions = null;
      this.inner_dimensions = null;
      this.rim_thickness = null;
      this.rim_step_height = null;
      this.rim_ledge = null;
      this.height_open_side = null;
      this.pose = null;
      this.pose_type = null;
    }
    else {
      if (initObj.hasOwnProperty('id')) {
        this.id = initObj.id
      }
      else {
        this.id = '';
      }
      if (initObj.hasOwnProperty('type')) {
        this.type = initObj.type
      }
      else {
        this.type = '';
      }
      if (initObj.hasOwnProperty('outer_dimensions')) {
        this.outer_dimensions = initObj.outer_dimensions
      }
      else {
        this.outer_dimensions = new Box();
      }
      if (initObj.hasOwnProperty('inner_dimensions')) {
        this.inner_dimensions = initObj.inner_dimensions
      }
      else {
        this.inner_dimensions = new Box();
      }
      if (initObj.hasOwnProperty('rim_thickness')) {
        this.rim_thickness = initObj.rim_thickness
      }
      else {
        this.rim_thickness = new Rectangle();
      }
      if (initObj.hasOwnProperty('rim_step_height')) {
        this.rim_step_height = initObj.rim_step_height
      }
      else {
        this.rim_step_height = 0.0;
      }
      if (initObj.hasOwnProperty('rim_ledge')) {
        this.rim_ledge = initObj.rim_ledge
      }
      else {
        this.rim_ledge = new Rectangle();
      }
      if (initObj.hasOwnProperty('height_open_side')) {
        this.height_open_side = initObj.height_open_side
      }
      else {
        this.height_open_side = 0.0;
      }
      if (initObj.hasOwnProperty('pose')) {
        this.pose = initObj.pose
      }
      else {
        this.pose = new geometry_msgs.msg.PoseStamped();
      }
      if (initObj.hasOwnProperty('pose_type')) {
        this.pose_type = initObj.pose_type
      }
      else {
        this.pose_type = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type LoadCarrierModel
    // Serialize message field [id]
    bufferOffset = _serializer.string(obj.id, buffer, bufferOffset);
    // Serialize message field [type]
    bufferOffset = _serializer.string(obj.type, buffer, bufferOffset);
    // Serialize message field [outer_dimensions]
    bufferOffset = Box.serialize(obj.outer_dimensions, buffer, bufferOffset);
    // Serialize message field [inner_dimensions]
    bufferOffset = Box.serialize(obj.inner_dimensions, buffer, bufferOffset);
    // Serialize message field [rim_thickness]
    bufferOffset = Rectangle.serialize(obj.rim_thickness, buffer, bufferOffset);
    // Serialize message field [rim_step_height]
    bufferOffset = _serializer.float64(obj.rim_step_height, buffer, bufferOffset);
    // Serialize message field [rim_ledge]
    bufferOffset = Rectangle.serialize(obj.rim_ledge, buffer, bufferOffset);
    // Serialize message field [height_open_side]
    bufferOffset = _serializer.float64(obj.height_open_side, buffer, bufferOffset);
    // Serialize message field [pose]
    bufferOffset = geometry_msgs.msg.PoseStamped.serialize(obj.pose, buffer, bufferOffset);
    // Serialize message field [pose_type]
    bufferOffset = _serializer.string(obj.pose_type, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type LoadCarrierModel
    let len;
    let data = new LoadCarrierModel(null);
    // Deserialize message field [id]
    data.id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [type]
    data.type = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [outer_dimensions]
    data.outer_dimensions = Box.deserialize(buffer, bufferOffset);
    // Deserialize message field [inner_dimensions]
    data.inner_dimensions = Box.deserialize(buffer, bufferOffset);
    // Deserialize message field [rim_thickness]
    data.rim_thickness = Rectangle.deserialize(buffer, bufferOffset);
    // Deserialize message field [rim_step_height]
    data.rim_step_height = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [rim_ledge]
    data.rim_ledge = Rectangle.deserialize(buffer, bufferOffset);
    // Deserialize message field [height_open_side]
    data.height_open_side = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [pose]
    data.pose = geometry_msgs.msg.PoseStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [pose_type]
    data.pose_type = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.id);
    length += _getByteLength(object.type);
    length += geometry_msgs.msg.PoseStamped.getMessageSize(object.pose);
    length += _getByteLength(object.pose_type);
    return length + 108;
  }

  static datatype() {
    // Returns string type for a message object
    return 'rc_reason_msgs/LoadCarrierModel';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '6e5092ac65ce482648fedf509c5f775d';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # This represents a load carrier by its geometry and its pose
    
    string id
    
    # Optional. The load carrier rim model. The only supported value is STANDARD
    string type
    
    # Required
    Box outer_dimensions
    
    # Required
    Box inner_dimensions
    
    # Optional. If not provided, the rim thickness is computed from the outer and inner dimensions
    Rectangle rim_thickness
    
    # Optional. Height of the rim step for rims with an L-profile.
    float64 rim_step_height
    
    # Optional. Length of the rim ledge in x and y direction. This requires rim_thickness to be set.
    Rectangle rim_ledge
    
    # Optional. Height of the open side of a 3-sided load carrier measured from the outer bottom.
    float64 height_open_side
    
    # When setting a load carrier, this is the prior if frame_id is not empty (should be 'camera' or 'external')
    geometry_msgs/PoseStamped pose
    
    # Optional. Indicates how to interpret the load carrier pose
    # If not set and pose is zero, it's equivalent to NO_POSE
    # If not set and any value in pose is not zero, it's equivalent to ORIENTATION_PRIOR
    # Valid values are:
    # NO_POSE
    # EXACT_POSE
    # ORIENTATION_PRIOR
    string pose_type
    
    ================================================================================
    MSG: rc_reason_msgs/Box
    # Definition of a box
    
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: rc_reason_msgs/Rectangle
    # Definition of a rectangle
    
    float64 x
    float64 y
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new LoadCarrierModel(null);
    if (msg.id !== undefined) {
      resolved.id = msg.id;
    }
    else {
      resolved.id = ''
    }

    if (msg.type !== undefined) {
      resolved.type = msg.type;
    }
    else {
      resolved.type = ''
    }

    if (msg.outer_dimensions !== undefined) {
      resolved.outer_dimensions = Box.Resolve(msg.outer_dimensions)
    }
    else {
      resolved.outer_dimensions = new Box()
    }

    if (msg.inner_dimensions !== undefined) {
      resolved.inner_dimensions = Box.Resolve(msg.inner_dimensions)
    }
    else {
      resolved.inner_dimensions = new Box()
    }

    if (msg.rim_thickness !== undefined) {
      resolved.rim_thickness = Rectangle.Resolve(msg.rim_thickness)
    }
    else {
      resolved.rim_thickness = new Rectangle()
    }

    if (msg.rim_step_height !== undefined) {
      resolved.rim_step_height = msg.rim_step_height;
    }
    else {
      resolved.rim_step_height = 0.0
    }

    if (msg.rim_ledge !== undefined) {
      resolved.rim_ledge = Rectangle.Resolve(msg.rim_ledge)
    }
    else {
      resolved.rim_ledge = new Rectangle()
    }

    if (msg.height_open_side !== undefined) {
      resolved.height_open_side = msg.height_open_side;
    }
    else {
      resolved.height_open_side = 0.0
    }

    if (msg.pose !== undefined) {
      resolved.pose = geometry_msgs.msg.PoseStamped.Resolve(msg.pose)
    }
    else {
      resolved.pose = new geometry_msgs.msg.PoseStamped()
    }

    if (msg.pose_type !== undefined) {
      resolved.pose_type = msg.pose_type;
    }
    else {
      resolved.pose_type = ''
    }

    return resolved;
    }
};

module.exports = LoadCarrierModel;
