// Auto-generated. Do not edit!

// (in-package rc_reason_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let shape_msgs = _finder('shape_msgs');
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

let rc_common_msgs = _finder('rc_common_msgs');

//-----------------------------------------------------------

class CalibrateBasePlaneRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.pose_frame = null;
      this.robot_pose = null;
      this.plane_estimation_method = null;
      this.stereo_plane_preference = null;
      this.region_of_interest_2d_id = null;
      this.offset = null;
      this.plane = null;
    }
    else {
      if (initObj.hasOwnProperty('pose_frame')) {
        this.pose_frame = initObj.pose_frame
      }
      else {
        this.pose_frame = '';
      }
      if (initObj.hasOwnProperty('robot_pose')) {
        this.robot_pose = initObj.robot_pose
      }
      else {
        this.robot_pose = new geometry_msgs.msg.Pose();
      }
      if (initObj.hasOwnProperty('plane_estimation_method')) {
        this.plane_estimation_method = initObj.plane_estimation_method
      }
      else {
        this.plane_estimation_method = '';
      }
      if (initObj.hasOwnProperty('stereo_plane_preference')) {
        this.stereo_plane_preference = initObj.stereo_plane_preference
      }
      else {
        this.stereo_plane_preference = '';
      }
      if (initObj.hasOwnProperty('region_of_interest_2d_id')) {
        this.region_of_interest_2d_id = initObj.region_of_interest_2d_id
      }
      else {
        this.region_of_interest_2d_id = '';
      }
      if (initObj.hasOwnProperty('offset')) {
        this.offset = initObj.offset
      }
      else {
        this.offset = 0.0;
      }
      if (initObj.hasOwnProperty('plane')) {
        this.plane = initObj.plane
      }
      else {
        this.plane = new shape_msgs.msg.Plane();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type CalibrateBasePlaneRequest
    // Serialize message field [pose_frame]
    bufferOffset = _serializer.string(obj.pose_frame, buffer, bufferOffset);
    // Serialize message field [robot_pose]
    bufferOffset = geometry_msgs.msg.Pose.serialize(obj.robot_pose, buffer, bufferOffset);
    // Serialize message field [plane_estimation_method]
    bufferOffset = _serializer.string(obj.plane_estimation_method, buffer, bufferOffset);
    // Serialize message field [stereo_plane_preference]
    bufferOffset = _serializer.string(obj.stereo_plane_preference, buffer, bufferOffset);
    // Serialize message field [region_of_interest_2d_id]
    bufferOffset = _serializer.string(obj.region_of_interest_2d_id, buffer, bufferOffset);
    // Serialize message field [offset]
    bufferOffset = _serializer.float64(obj.offset, buffer, bufferOffset);
    // Serialize message field [plane]
    bufferOffset = shape_msgs.msg.Plane.serialize(obj.plane, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type CalibrateBasePlaneRequest
    let len;
    let data = new CalibrateBasePlaneRequest(null);
    // Deserialize message field [pose_frame]
    data.pose_frame = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [robot_pose]
    data.robot_pose = geometry_msgs.msg.Pose.deserialize(buffer, bufferOffset);
    // Deserialize message field [plane_estimation_method]
    data.plane_estimation_method = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [stereo_plane_preference]
    data.stereo_plane_preference = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [region_of_interest_2d_id]
    data.region_of_interest_2d_id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [offset]
    data.offset = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [plane]
    data.plane = shape_msgs.msg.Plane.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.pose_frame);
    length += _getByteLength(object.plane_estimation_method);
    length += _getByteLength(object.stereo_plane_preference);
    length += _getByteLength(object.region_of_interest_2d_id);
    return length + 112;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_reason_msgs/CalibrateBasePlaneRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'd58aded4c080e1ca21cab9f38fcefb17';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Description: Triggers base-plane calibration.
    
    # Required. Pose frame for output poses (valid values are camera and external)
    string pose_frame
    
    # Required only if reference frame = external and sensor is robot-mounted
    geometry_msgs/Pose robot_pose
    
    # Required. Method to use for base-plane estimation
    # Valid values are:
    # STEREO
    # APRILTAG
    # MANUAL
    string plane_estimation_method
    
    # Options for STEREO calibration
    string stereo_plane_preference
    
    # Optional
    string region_of_interest_2d_id
    
    # Optional. Shift in meters that will be applied to the estimated plane
    float64 offset
    
    # Reqired only if plane_estimation_method = MANUAL
    shape_msgs/Plane plane
    
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: shape_msgs/Plane
    # Representation of a plane, using the plane equation ax + by + cz + d = 0
    
    # a := coef[0]
    # b := coef[1]
    # c := coef[2]
    # d := coef[3]
    
    float64[4] coef
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new CalibrateBasePlaneRequest(null);
    if (msg.pose_frame !== undefined) {
      resolved.pose_frame = msg.pose_frame;
    }
    else {
      resolved.pose_frame = ''
    }

    if (msg.robot_pose !== undefined) {
      resolved.robot_pose = geometry_msgs.msg.Pose.Resolve(msg.robot_pose)
    }
    else {
      resolved.robot_pose = new geometry_msgs.msg.Pose()
    }

    if (msg.plane_estimation_method !== undefined) {
      resolved.plane_estimation_method = msg.plane_estimation_method;
    }
    else {
      resolved.plane_estimation_method = ''
    }

    if (msg.stereo_plane_preference !== undefined) {
      resolved.stereo_plane_preference = msg.stereo_plane_preference;
    }
    else {
      resolved.stereo_plane_preference = ''
    }

    if (msg.region_of_interest_2d_id !== undefined) {
      resolved.region_of_interest_2d_id = msg.region_of_interest_2d_id;
    }
    else {
      resolved.region_of_interest_2d_id = ''
    }

    if (msg.offset !== undefined) {
      resolved.offset = msg.offset;
    }
    else {
      resolved.offset = 0.0
    }

    if (msg.plane !== undefined) {
      resolved.plane = shape_msgs.msg.Plane.Resolve(msg.plane)
    }
    else {
      resolved.plane = new shape_msgs.msg.Plane()
    }

    return resolved;
    }
};

class CalibrateBasePlaneResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.timestamp = null;
      this.pose_frame = null;
      this.plane = null;
      this.return_code = null;
    }
    else {
      if (initObj.hasOwnProperty('timestamp')) {
        this.timestamp = initObj.timestamp
      }
      else {
        this.timestamp = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('pose_frame')) {
        this.pose_frame = initObj.pose_frame
      }
      else {
        this.pose_frame = '';
      }
      if (initObj.hasOwnProperty('plane')) {
        this.plane = initObj.plane
      }
      else {
        this.plane = new shape_msgs.msg.Plane();
      }
      if (initObj.hasOwnProperty('return_code')) {
        this.return_code = initObj.return_code
      }
      else {
        this.return_code = new rc_common_msgs.msg.ReturnCode();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type CalibrateBasePlaneResponse
    // Serialize message field [timestamp]
    bufferOffset = _serializer.time(obj.timestamp, buffer, bufferOffset);
    // Serialize message field [pose_frame]
    bufferOffset = _serializer.string(obj.pose_frame, buffer, bufferOffset);
    // Serialize message field [plane]
    bufferOffset = shape_msgs.msg.Plane.serialize(obj.plane, buffer, bufferOffset);
    // Serialize message field [return_code]
    bufferOffset = rc_common_msgs.msg.ReturnCode.serialize(obj.return_code, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type CalibrateBasePlaneResponse
    let len;
    let data = new CalibrateBasePlaneResponse(null);
    // Deserialize message field [timestamp]
    data.timestamp = _deserializer.time(buffer, bufferOffset);
    // Deserialize message field [pose_frame]
    data.pose_frame = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [plane]
    data.plane = shape_msgs.msg.Plane.deserialize(buffer, bufferOffset);
    // Deserialize message field [return_code]
    data.return_code = rc_common_msgs.msg.ReturnCode.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.pose_frame);
    length += rc_common_msgs.msg.ReturnCode.getMessageSize(object.return_code);
    return length + 44;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_reason_msgs/CalibrateBasePlaneResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '66a1e5e08f95956586a3597145befd96';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    # timestamp of the image set the calibration ran on
    time timestamp
    
    # frame in which plane is given
    string pose_frame
    shape_msgs/Plane plane
    
    rc_common_msgs/ReturnCode return_code
    
    
    ================================================================================
    MSG: shape_msgs/Plane
    # Representation of a plane, using the plane equation ax + by + cz + d = 0
    
    # a := coef[0]
    # b := coef[1]
    # c := coef[2]
    # d := coef[3]
    
    float64[4] coef
    
    ================================================================================
    MSG: rc_common_msgs/ReturnCode
    # This message shall be used in the response of services as a field called return_code.
    # Confer to ReturnCodeConsts message for commonly used return code definitions.
    
    # return codes
    # >=0 - success
    # < 0 - failure
    
    # return code
    int16 value
    
    # return message
    string message
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new CalibrateBasePlaneResponse(null);
    if (msg.timestamp !== undefined) {
      resolved.timestamp = msg.timestamp;
    }
    else {
      resolved.timestamp = {secs: 0, nsecs: 0}
    }

    if (msg.pose_frame !== undefined) {
      resolved.pose_frame = msg.pose_frame;
    }
    else {
      resolved.pose_frame = ''
    }

    if (msg.plane !== undefined) {
      resolved.plane = shape_msgs.msg.Plane.Resolve(msg.plane)
    }
    else {
      resolved.plane = new shape_msgs.msg.Plane()
    }

    if (msg.return_code !== undefined) {
      resolved.return_code = rc_common_msgs.msg.ReturnCode.Resolve(msg.return_code)
    }
    else {
      resolved.return_code = new rc_common_msgs.msg.ReturnCode()
    }

    return resolved;
    }
};

module.exports = {
  Request: CalibrateBasePlaneRequest,
  Response: CalibrateBasePlaneResponse,
  md5sum() { return 'e925f2902c2418e2f833f0750df2a099'; },
  datatype() { return 'rc_reason_msgs/CalibrateBasePlane'; }
};
