// Auto-generated. Do not edit!

// (in-package rc_reason_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------


//-----------------------------------------------------------

class SetHandEyeCalibrationPoseRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.slot = null;
      this.pose = null;
    }
    else {
      if (initObj.hasOwnProperty('slot')) {
        this.slot = initObj.slot
      }
      else {
        this.slot = 0;
      }
      if (initObj.hasOwnProperty('pose')) {
        this.pose = initObj.pose
      }
      else {
        this.pose = new geometry_msgs.msg.Pose();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SetHandEyeCalibrationPoseRequest
    // Serialize message field [slot]
    bufferOffset = _serializer.int32(obj.slot, buffer, bufferOffset);
    // Serialize message field [pose]
    bufferOffset = geometry_msgs.msg.Pose.serialize(obj.pose, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SetHandEyeCalibrationPoseRequest
    let len;
    let data = new SetHandEyeCalibrationPoseRequest(null);
    // Deserialize message field [slot]
    data.slot = _deserializer.int32(buffer, bufferOffset);
    // Deserialize message field [pose]
    data.pose = geometry_msgs.msg.Pose.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 60;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_reason_msgs/SetHandEyeCalibrationPoseRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '4d46a8ae18ce2288c122e6748a045ac4';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Description: Save a pose (grid or gripper) for later calibration.
    #Request
    #Slot in which the pose-image pair is stored.
    #Required for overwriting previously stored data (by using the same slot again).
    int32 slot
    geometry_msgs/Pose pose
    
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SetHandEyeCalibrationPoseRequest(null);
    if (msg.slot !== undefined) {
      resolved.slot = msg.slot;
    }
    else {
      resolved.slot = 0
    }

    if (msg.pose !== undefined) {
      resolved.pose = geometry_msgs.msg.Pose.Resolve(msg.pose)
    }
    else {
      resolved.pose = new geometry_msgs.msg.Pose()
    }

    return resolved;
    }
};

class SetHandEyeCalibrationPoseResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.success = null;
      this.status = null;
      this.message = null;
    }
    else {
      if (initObj.hasOwnProperty('success')) {
        this.success = initObj.success
      }
      else {
        this.success = false;
      }
      if (initObj.hasOwnProperty('status')) {
        this.status = initObj.status
      }
      else {
        this.status = 0;
      }
      if (initObj.hasOwnProperty('message')) {
        this.message = initObj.message
      }
      else {
        this.message = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SetHandEyeCalibrationPoseResponse
    // Serialize message field [success]
    bufferOffset = _serializer.bool(obj.success, buffer, bufferOffset);
    // Serialize message field [status]
    bufferOffset = _serializer.int32(obj.status, buffer, bufferOffset);
    // Serialize message field [message]
    bufferOffset = _serializer.string(obj.message, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SetHandEyeCalibrationPoseResponse
    let len;
    let data = new SetHandEyeCalibrationPoseResponse(null);
    // Deserialize message field [success]
    data.success = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [status]
    data.status = _deserializer.int32(buffer, bufferOffset);
    // Deserialize message field [message]
    data.message = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.message);
    return length + 9;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_reason_msgs/SetHandEyeCalibrationPoseResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'b4bfdb0b744cd515a4bbfd58abf81bb5';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    #True if grid was detected and stored together with the pose in the given slot
    bool success
    #Internal status:
    #1: Grid detected, pose stored
    #3: Grid detected, pose stored. Ready to calibrate
    #4: Insufficient detection of the calibration pattern
    #8: No image data available
    #12: Invalid orientation given (0,0,0)
    int32 status
    #Human readable message, for development
    string message
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SetHandEyeCalibrationPoseResponse(null);
    if (msg.success !== undefined) {
      resolved.success = msg.success;
    }
    else {
      resolved.success = false
    }

    if (msg.status !== undefined) {
      resolved.status = msg.status;
    }
    else {
      resolved.status = 0
    }

    if (msg.message !== undefined) {
      resolved.message = msg.message;
    }
    else {
      resolved.message = ''
    }

    return resolved;
    }
};

module.exports = {
  Request: SetHandEyeCalibrationPoseRequest,
  Response: SetHandEyeCalibrationPoseResponse,
  md5sum() { return '428368a0837b2cd361293f0db06533a0'; },
  datatype() { return 'rc_reason_msgs/SetHandEyeCalibrationPose'; }
};
