// Auto-generated. Do not edit!

// (in-package rc_reason_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let SilhouetteMatchObject = require('../msg/SilhouetteMatchObject.js');
let CollisionDetection = require('../msg/CollisionDetection.js');
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

let Match = require('../msg/Match.js');
let Grasp = require('../msg/Grasp.js');
let LoadCarrier = require('../msg/LoadCarrier.js');
let rc_common_msgs = _finder('rc_common_msgs');

//-----------------------------------------------------------

class SilhouetteMatchDetectObjectRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.object_to_detect = null;
      this.offset = null;
      this.pose_frame = null;
      this.robot_pose = null;
      this.load_carrier_id = null;
      this.collision_detection = null;
      this.object_plane_detection = null;
    }
    else {
      if (initObj.hasOwnProperty('object_to_detect')) {
        this.object_to_detect = initObj.object_to_detect
      }
      else {
        this.object_to_detect = new SilhouetteMatchObject();
      }
      if (initObj.hasOwnProperty('offset')) {
        this.offset = initObj.offset
      }
      else {
        this.offset = 0.0;
      }
      if (initObj.hasOwnProperty('pose_frame')) {
        this.pose_frame = initObj.pose_frame
      }
      else {
        this.pose_frame = '';
      }
      if (initObj.hasOwnProperty('robot_pose')) {
        this.robot_pose = initObj.robot_pose
      }
      else {
        this.robot_pose = new geometry_msgs.msg.Pose();
      }
      if (initObj.hasOwnProperty('load_carrier_id')) {
        this.load_carrier_id = initObj.load_carrier_id
      }
      else {
        this.load_carrier_id = '';
      }
      if (initObj.hasOwnProperty('collision_detection')) {
        this.collision_detection = initObj.collision_detection
      }
      else {
        this.collision_detection = new CollisionDetection();
      }
      if (initObj.hasOwnProperty('object_plane_detection')) {
        this.object_plane_detection = initObj.object_plane_detection
      }
      else {
        this.object_plane_detection = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SilhouetteMatchDetectObjectRequest
    // Serialize message field [object_to_detect]
    bufferOffset = SilhouetteMatchObject.serialize(obj.object_to_detect, buffer, bufferOffset);
    // Serialize message field [offset]
    bufferOffset = _serializer.float64(obj.offset, buffer, bufferOffset);
    // Serialize message field [pose_frame]
    bufferOffset = _serializer.string(obj.pose_frame, buffer, bufferOffset);
    // Serialize message field [robot_pose]
    bufferOffset = geometry_msgs.msg.Pose.serialize(obj.robot_pose, buffer, bufferOffset);
    // Serialize message field [load_carrier_id]
    bufferOffset = _serializer.string(obj.load_carrier_id, buffer, bufferOffset);
    // Serialize message field [collision_detection]
    bufferOffset = CollisionDetection.serialize(obj.collision_detection, buffer, bufferOffset);
    // Serialize message field [object_plane_detection]
    bufferOffset = _serializer.bool(obj.object_plane_detection, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SilhouetteMatchDetectObjectRequest
    let len;
    let data = new SilhouetteMatchDetectObjectRequest(null);
    // Deserialize message field [object_to_detect]
    data.object_to_detect = SilhouetteMatchObject.deserialize(buffer, bufferOffset);
    // Deserialize message field [offset]
    data.offset = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [pose_frame]
    data.pose_frame = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [robot_pose]
    data.robot_pose = geometry_msgs.msg.Pose.deserialize(buffer, bufferOffset);
    // Deserialize message field [load_carrier_id]
    data.load_carrier_id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [collision_detection]
    data.collision_detection = CollisionDetection.deserialize(buffer, bufferOffset);
    // Deserialize message field [object_plane_detection]
    data.object_plane_detection = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += SilhouetteMatchObject.getMessageSize(object.object_to_detect);
    length += _getByteLength(object.pose_frame);
    length += _getByteLength(object.load_carrier_id);
    length += CollisionDetection.getMessageSize(object.collision_detection);
    return length + 73;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_reason_msgs/SilhouetteMatchDetectObjectRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'b1bac175d56bab5de63703b056f85172';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Description: Triggers detection of an object.
    
    # Required. Object that is to be detected
    SilhouetteMatchObject object_to_detect
    
    # Optional. Shift in meters that will be applied to the calibrated base-plane
    float64 offset
    
    # Required. Pose frame for output poses (valid values are camera and external)
    string pose_frame
    
    # Required only if reference frame = external and sensor is robot-mounted
    geometry_msgs/Pose robot_pose
    
    # Optional
    string load_carrier_id
    
    # Optional. Enables collision checking of grasps with load carrier
    CollisionDetection collision_detection
    
    # Optional. Activates SilhouetteMatch from automatically detected planes
    bool object_plane_detection
    
    
    ================================================================================
    MSG: rc_reason_msgs/SilhouetteMatchObject
    # ID of the object
    string object_id
    
    # ROI in which to detect the object
    string region_of_interest_2d_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: rc_reason_msgs/CollisionDetection
    string gripper_id
    
    geometry_msgs/Point pre_grasp_offset
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SilhouetteMatchDetectObjectRequest(null);
    if (msg.object_to_detect !== undefined) {
      resolved.object_to_detect = SilhouetteMatchObject.Resolve(msg.object_to_detect)
    }
    else {
      resolved.object_to_detect = new SilhouetteMatchObject()
    }

    if (msg.offset !== undefined) {
      resolved.offset = msg.offset;
    }
    else {
      resolved.offset = 0.0
    }

    if (msg.pose_frame !== undefined) {
      resolved.pose_frame = msg.pose_frame;
    }
    else {
      resolved.pose_frame = ''
    }

    if (msg.robot_pose !== undefined) {
      resolved.robot_pose = geometry_msgs.msg.Pose.Resolve(msg.robot_pose)
    }
    else {
      resolved.robot_pose = new geometry_msgs.msg.Pose()
    }

    if (msg.load_carrier_id !== undefined) {
      resolved.load_carrier_id = msg.load_carrier_id;
    }
    else {
      resolved.load_carrier_id = ''
    }

    if (msg.collision_detection !== undefined) {
      resolved.collision_detection = CollisionDetection.Resolve(msg.collision_detection)
    }
    else {
      resolved.collision_detection = new CollisionDetection()
    }

    if (msg.object_plane_detection !== undefined) {
      resolved.object_plane_detection = msg.object_plane_detection;
    }
    else {
      resolved.object_plane_detection = false
    }

    return resolved;
    }
};

class SilhouetteMatchDetectObjectResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.timestamp = null;
      this.object_id = null;
      this.matches = null;
      this.grasps = null;
      this.load_carriers = null;
      this.return_code = null;
    }
    else {
      if (initObj.hasOwnProperty('timestamp')) {
        this.timestamp = initObj.timestamp
      }
      else {
        this.timestamp = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('object_id')) {
        this.object_id = initObj.object_id
      }
      else {
        this.object_id = '';
      }
      if (initObj.hasOwnProperty('matches')) {
        this.matches = initObj.matches
      }
      else {
        this.matches = [];
      }
      if (initObj.hasOwnProperty('grasps')) {
        this.grasps = initObj.grasps
      }
      else {
        this.grasps = [];
      }
      if (initObj.hasOwnProperty('load_carriers')) {
        this.load_carriers = initObj.load_carriers
      }
      else {
        this.load_carriers = [];
      }
      if (initObj.hasOwnProperty('return_code')) {
        this.return_code = initObj.return_code
      }
      else {
        this.return_code = new rc_common_msgs.msg.ReturnCode();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SilhouetteMatchDetectObjectResponse
    // Serialize message field [timestamp]
    bufferOffset = _serializer.time(obj.timestamp, buffer, bufferOffset);
    // Serialize message field [object_id]
    bufferOffset = _serializer.string(obj.object_id, buffer, bufferOffset);
    // Serialize message field [matches]
    // Serialize the length for message field [matches]
    bufferOffset = _serializer.uint32(obj.matches.length, buffer, bufferOffset);
    obj.matches.forEach((val) => {
      bufferOffset = Match.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [grasps]
    // Serialize the length for message field [grasps]
    bufferOffset = _serializer.uint32(obj.grasps.length, buffer, bufferOffset);
    obj.grasps.forEach((val) => {
      bufferOffset = Grasp.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [load_carriers]
    // Serialize the length for message field [load_carriers]
    bufferOffset = _serializer.uint32(obj.load_carriers.length, buffer, bufferOffset);
    obj.load_carriers.forEach((val) => {
      bufferOffset = LoadCarrier.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [return_code]
    bufferOffset = rc_common_msgs.msg.ReturnCode.serialize(obj.return_code, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SilhouetteMatchDetectObjectResponse
    let len;
    let data = new SilhouetteMatchDetectObjectResponse(null);
    // Deserialize message field [timestamp]
    data.timestamp = _deserializer.time(buffer, bufferOffset);
    // Deserialize message field [object_id]
    data.object_id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [matches]
    // Deserialize array length for message field [matches]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.matches = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.matches[i] = Match.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [grasps]
    // Deserialize array length for message field [grasps]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.grasps = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.grasps[i] = Grasp.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [load_carriers]
    // Deserialize array length for message field [load_carriers]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.load_carriers = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.load_carriers[i] = LoadCarrier.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [return_code]
    data.return_code = rc_common_msgs.msg.ReturnCode.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.object_id);
    object.matches.forEach((val) => {
      length += Match.getMessageSize(val);
    });
    object.grasps.forEach((val) => {
      length += Grasp.getMessageSize(val);
    });
    object.load_carriers.forEach((val) => {
      length += LoadCarrier.getMessageSize(val);
    });
    length += rc_common_msgs.msg.ReturnCode.getMessageSize(object.return_code);
    return length + 24;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_reason_msgs/SilhouetteMatchDetectObjectResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'fbb1bc21f00c276d4057d14e02a93a13';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    time timestamp
    
    string object_id
    
    # List of detected matches (instances) of the object
    Match[] matches
    
    Grasp[] grasps
    
    LoadCarrier[] load_carriers
    
    rc_common_msgs/ReturnCode return_code
    
    
    ================================================================================
    MSG: rc_reason_msgs/Match
    # id of template which was matched
    string template_id
    
    # unique id of this match
    string uuid
    
    geometry_msgs/PoseStamped pose
    
    # associated grasps
    string[] grasp_uuids
    
    # how well the object matches the template (-1 if not available)
    float64 score
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: rc_reason_msgs/Grasp
    # Definition of a grasp
    
    # user defined id (name)
    string id
    
    # unique id of this grasp
    string uuid
    
    # unique id of the match this grasp is associated to
    string match_uuid
    
    geometry_msgs/PoseStamped pose
    
    # Optional
    int8 priority
    
    string gripper_id
    
    bool collision_checked
    
    ================================================================================
    MSG: rc_reason_msgs/LoadCarrier
    # This represents a detected load carrier by its geometry and its pose
    
    string id
    
    # Optional. The load carrier rim model. The only supported value is STANDARD
    string type
    
    # Required
    Box outer_dimensions
    
    # Required
    Box inner_dimensions
    
    # Optional. If not provided, the rim thickness is computed from the outer and inner dimensions
    Rectangle rim_thickness
    
    # Optional. Height of the rim step for rims with an L-profile.
    float64 rim_step_height
    
    # Optional. Length of the rim ledge in x and y direction. This requires rim_thickness to be set.
    Rectangle rim_ledge
    
    # Optional. Height of the open side of a 3-sided load carrier measured from the outer bottom.
    float64 height_open_side
    
    geometry_msgs/PoseStamped pose
    
    # True if a detected load carrier is overfilled. Ignored on setting load carrier.
    bool overfilled
    
    ================================================================================
    MSG: rc_reason_msgs/Box
    # Definition of a box
    
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: rc_reason_msgs/Rectangle
    # Definition of a rectangle
    
    float64 x
    float64 y
    
    ================================================================================
    MSG: rc_common_msgs/ReturnCode
    # This message shall be used in the response of services as a field called return_code.
    # Confer to ReturnCodeConsts message for commonly used return code definitions.
    
    # return codes
    # >=0 - success
    # < 0 - failure
    
    # return code
    int16 value
    
    # return message
    string message
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SilhouetteMatchDetectObjectResponse(null);
    if (msg.timestamp !== undefined) {
      resolved.timestamp = msg.timestamp;
    }
    else {
      resolved.timestamp = {secs: 0, nsecs: 0}
    }

    if (msg.object_id !== undefined) {
      resolved.object_id = msg.object_id;
    }
    else {
      resolved.object_id = ''
    }

    if (msg.matches !== undefined) {
      resolved.matches = new Array(msg.matches.length);
      for (let i = 0; i < resolved.matches.length; ++i) {
        resolved.matches[i] = Match.Resolve(msg.matches[i]);
      }
    }
    else {
      resolved.matches = []
    }

    if (msg.grasps !== undefined) {
      resolved.grasps = new Array(msg.grasps.length);
      for (let i = 0; i < resolved.grasps.length; ++i) {
        resolved.grasps[i] = Grasp.Resolve(msg.grasps[i]);
      }
    }
    else {
      resolved.grasps = []
    }

    if (msg.load_carriers !== undefined) {
      resolved.load_carriers = new Array(msg.load_carriers.length);
      for (let i = 0; i < resolved.load_carriers.length; ++i) {
        resolved.load_carriers[i] = LoadCarrier.Resolve(msg.load_carriers[i]);
      }
    }
    else {
      resolved.load_carriers = []
    }

    if (msg.return_code !== undefined) {
      resolved.return_code = rc_common_msgs.msg.ReturnCode.Resolve(msg.return_code)
    }
    else {
      resolved.return_code = new rc_common_msgs.msg.ReturnCode()
    }

    return resolved;
    }
};

module.exports = {
  Request: SilhouetteMatchDetectObjectRequest,
  Response: SilhouetteMatchDetectObjectResponse,
  md5sum() { return '96691fd377f2dfe11418e7c107777964'; },
  datatype() { return 'rc_reason_msgs/SilhouetteMatchDetectObject'; }
};
